import { ElementRef, EventEmitter, NgZone, OnDestroy, OnInit, ChangeDetectorRef } from '@angular/core';
import * as THREE from 'three';
import * as i0 from "@angular/core";
export interface MeshOptions {
    castShadow?: boolean;
    position?: THREE.Vector3;
    receiveShadow?: boolean;
    scale?: THREE.Vector3;
    up?: THREE.Vector3;
    userData?: {
        [key: string]: any;
    };
    visible?: boolean;
}
export declare class StlModelViewerComponent implements OnInit, OnDestroy {
    private cdr;
    private eleRef;
    private ngZone;
    stlModels: string[];
    stlModelFiles: string[];
    hasControls: boolean;
    camera: THREE.PerspectiveCamera;
    cameraTarget: THREE.Vector3;
    light: THREE.Light;
    material: THREE.Material;
    scene: THREE.Scene;
    renderer: THREE.WebGLRenderer;
    controls: any | null;
    meshOptions: MeshOptions[];
    centered: boolean;
    rendered: EventEmitter<void>;
    hasWebGL: boolean;
    meshGroup: any;
    isRendered: boolean;
    showStlModel: boolean;
    stlLoader: any;
    middle: any;
    constructor(cdr: ChangeDetectorRef, eleRef: ElementRef, ngZone: NgZone);
    ngOnInit(): void;
    ngOnDestroy(): void;
    createMesh(path: string, meshOptions?: MeshOptions, parse?: boolean): Promise<THREE.Mesh>;
    render: () => void;
    setSizes(): void;
    onWindowResize: () => void;
    private init;
    static ɵfac: i0.ɵɵFactoryDeclaration<StlModelViewerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<StlModelViewerComponent, "stl-model-viewer", never, { "stlModels": "stlModels"; "stlModelFiles": "stlModelFiles"; "hasControls": "hasControls"; "camera": "camera"; "cameraTarget": "cameraTarget"; "light": "light"; "material": "material"; "scene": "scene"; "renderer": "renderer"; "controls": "controls"; "meshOptions": "meshOptions"; "centered": "centered"; }, { "rendered": "rendered"; }, never, never>;
}
